"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var photobookUrl = 'https://photobook.kite.ly';
var KitePhotobookSDK = (function () {
    function KitePhotobookSDK(_window) {
        this._window = _window;
        this.printEngineBaseUrl = 'https://print-engine.prodigi.com/v1';
    }
    KitePhotobookSDK.prototype.launchPhotobook = function (launchData) {
        var _this = this;
        var issues = [];
        if (launchData.images.some(function (image) { return !_this._isValidPicture(image); })) {
            issues.push('The sent pictures are not valid');
        }
        if (issues.length > 0) {
            issues.forEach(function (issue) {
                console.error(issue);
            });
            return;
        }
        if (launchData.images.some(function (image) { return !image.dimensions; })) {
            this.fillMissingDimensions(launchData.images).then(function (processedImages) {
                launchData.images = processedImages;
                _this.finaliseData(launchData);
            });
        }
        else {
            this.finaliseData(launchData);
        }
    };
    KitePhotobookSDK.prototype.launchSavedBook = function (_a) {
        var _b = _a.baseUrl, baseUrl = _b === void 0 ? photobookUrl : _b, brand = _a.brand, checkout = _a.checkout, clearOptions = _a.clearOptions, customPartnerConfig = _a.customPartnerConfig, partnerLogoLinkUrl = _a.partnerLogoLinkUrl, savedBookData = _a.savedBookData, _c = _a.addNewImagesToBook, addNewImagesToBook = _c === void 0 ? false : _c, _d = _a.clearBook, clearBook = _d === void 0 ? true : _d, bookSpineText = _a.bookSpineText, referenceId = _a.referenceId, variantTemplateId = _a.variantTemplateId;
        var dataToPost = {
            addNewImagesToBook: addNewImagesToBook,
            bookSpineText: bookSpineText,
            checkout: checkout,
            clearBook: clearBook,
            clearOptions: clearOptions,
            customPartnerConfig: customPartnerConfig,
            partnerLogoLinkUrl: partnerLogoLinkUrl,
            referenceId: referenceId,
            savedBookData: savedBookData,
            variantTemplateId: variantTemplateId,
        };
        this.post(baseUrl + "/" + (brand ? brand + '/' : ''), JSON.stringify(dataToPost));
    };
    KitePhotobookSDK.prototype.finaliseData = function (_a) {
        var _b = _a.baseUrl, baseUrl = _b === void 0 ? photobookUrl : _b, brand = _a.brand, checkout = _a.checkout, clearOptions = _a.clearOptions, config = _a.config, customPartnerConfig = _a.customPartnerConfig, partnerLogoLinkUrl = _a.partnerLogoLinkUrl, images = _a.images, _c = _a.clearBook, clearBook = _c === void 0 ? false : _c, checkoutFields = _a.checkoutFields, _d = _a.addNewImagesToBook, addNewImagesToBook = _d === void 0 ? false : _d, bookSpineText = _a.bookSpineText, referenceId = _a.referenceId, variantTemplateId = _a.variantTemplateId;
        var pictureUploads = images.map(function (image) { return ({
            isUploadComplete: true,
            picture: image,
            timesUsedInProduct: 0,
        }); });
        var dataToPost = {
            addNewImagesToBook: addNewImagesToBook,
            bookSpineText: bookSpineText,
            checkout: checkout,
            clearBook: clearBook,
            clearOptions: clearOptions,
            config: config,
            customPartnerConfig: customPartnerConfig,
            partnerLogoLinkUrl: partnerLogoLinkUrl,
            referenceId: referenceId,
            savedBookData: JSON.stringify({
                checkoutFields: checkoutFields,
                images: {
                    pictureUploads: pictureUploads,
                },
            }),
            variantTemplateId: variantTemplateId,
        };
        this.post(baseUrl + "/" + (brand ? brand + '/' : ''), JSON.stringify(dataToPost));
    };
    KitePhotobookSDK.prototype.post = function (path, jsonData) {
        var _this = this;
        var parsedData = JSON.parse(jsonData);
        var shouldStartInNewTab = (parsedData.hasOwnProperty('config') &&
            parsedData.config.startInNewTab) ? true : false;
        var newWindow;
        if (shouldStartInNewTab) {
            newWindow = window.open('', '_blank');
        }
        fetch(this.printEngineBaseUrl + '/post-data/', {
            body: jsonData,
            method: 'POST',
        })
            .then(function (response) {
            if (!response.ok) {
                throw new Error(response.statusText);
            }
            return response.json();
        })
            .then(function (postedDataId) {
            _this.launchWithPostedData(path, postedDataId, newWindow);
        })
            .catch(function (err) {
            if (newWindow) {
                newWindow.close();
            }
            throw new Error(err);
        });
    };
    KitePhotobookSDK.prototype.launchWithPostedData = function (path, postedDataId, newWindow) {
        var splitPathByHash = path.split('#');
        var pathBeforeHash = splitPathByHash[0];
        var pathAfterHash = splitPathByHash[1];
        var pathWithPostedData = pathBeforeHash + '?postedDataId=' + postedDataId;
        var goToUrl = pathWithPostedData;
        if (pathAfterHash) {
            goToUrl += '#' + pathAfterHash;
        }
        if (newWindow) {
            newWindow.location.assign(goToUrl);
            newWindow.focus();
        }
        else {
            window.location.assign(goToUrl);
        }
    };
    KitePhotobookSDK.prototype._isValidPicture = function (picture) {
        return Boolean(picture &&
            picture.thumbnailUrl &&
            picture.url);
    };
    KitePhotobookSDK.prototype.loadImages = function (imagesData) {
        return __awaiter(this, void 0, void 0, function () {
            var promiseArray, imagesArray, _loop_1, _i, imagesData_1, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        promiseArray = [];
                        imagesArray = [];
                        _loop_1 = function (data) {
                            promiseArray.push(new Promise(function (resolve) {
                                var img = new Image();
                                img.onload = resolve;
                                img.src = data.url;
                                imagesArray.push({
                                    img: img,
                                    index: data.index,
                                    url: data.url,
                                });
                            }));
                        };
                        for (_i = 0, imagesData_1 = imagesData; _i < imagesData_1.length; _i++) {
                            data = imagesData_1[_i];
                            _loop_1(data);
                        }
                        return [4, Promise.all(promiseArray)];
                    case 1:
                        _a.sent();
                        return [2, imagesArray];
                }
            });
        });
    };
    KitePhotobookSDK.prototype.fillMissingDimensions = function (images) {
        return __awaiter(this, void 0, void 0, function () {
            var processedImages, imageUrls;
            return __generator(this, function (_a) {
                processedImages = images;
                imageUrls = [];
                images.forEach(function (image, index) {
                    if (!image.dimensions) {
                        imageUrls.push({
                            index: index,
                            url: image.url,
                        });
                    }
                });
                return [2, this.loadImages(imageUrls).then(function (imagesReceived) {
                        imagesReceived.forEach(function (imageData) {
                            processedImages[imageData.index].dimensions = {
                                height: imageData.img.height,
                                width: imageData.img.width,
                            };
                        });
                        return processedImages;
                    })];
            });
        });
    };
    return KitePhotobookSDK;
}());
exports.KitePhotobookSDK = KitePhotobookSDK;
